scala.xml.include.sax

# XIncludeFilter

#### class XIncludeFilter extends XMLFilterImpl

This is a SAX filter which resolves all XInclude include elements before passing them on to the client application. Currently this class has the following known deviation from the XInclude specification:

1. XPointer is not supported.

Furthermore, I would definitely use a new instance of this class for each document you want to process. I doubt it can be used successfully on multiple documents. Furthermore, I can virtually guarantee that this class is not thread safe. You have been warned.

Since this class is not designed to be subclassed, and since I have not yet considered how that might affect the methods herein or what other protected methods might be needed to support subclasses, I have declared this class final. I may remove this restriction later, though the use-case for subclassing is weak. This class is designed to have its functionality extended via a horizontal chain of filters, not a vertical hierarchy of sub and superclasses.

To use this class:

- Construct an `XIncludeFilter` object with a known base URL
- Pass the `XMLReader` object from which the raw document will be read to the `setParent()` method of this object.
- Pass your own `ContentHandler` object to the `setContentHandler()` method of this object. This is the object which will receive events from the parsed and included document.
- Optional: if you wish to receive comments, set your own `LexicalHandler` object as the value of this object's `http://xml.org/sax/properties/lexical-handler` property. Also make sure your `LexicalHandler` asks this object for the status of each comment using `insideIncludeElement` before doing anything with the comment.
- Pass the URL of the document to read to this object's `parse()` method

e.g.

    val includer = new XIncludeFilter(base)
    includer setParent parser
    includer setContentHandler new SAXXIncluder(System.out)
    includer parse args(i)

translated from Elliotte Rusty Harold's Java source.

Source
  XIncludeFilter.scala

Linear Supertypes
XMLFilterImpl, ErrorHandler, ContentHandler, DTDHandler, org.xml.sax.EntityResolver, XMLFilter, XMLReader, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. XIncludeFilter
2. XMLFilterImpl
3. ErrorHandler
4. ContentHandler
5. DTDHandler
6. EntityResolver
7. XMLFilter
8. XMLReader
9. AnyRef
10. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new XIncludeFilter()

### Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from XIncludeFilter to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (XIncludeFilter, B)

   Implicit information
     This member is added by an implicit conversion from XIncludeFilter to ArrowAssoc[XIncludeFilter] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality. The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

8. #### final val XINCLUDE_NAMESPACE: String("http://www.w3.org/2001/XInclude")

9. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

10. #### def characters(ch: Array[Char], start: Int, length: Int): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

11. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

12. #### def endDocument(): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

13. #### def endElement(uri: String, localName: String, qName: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

14. #### def endPrefixMapping(prefix: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

15. #### def ensuring(cond: (XIncludeFilter) ⇒ Boolean, msg: ⇒ Any): XIncludeFilter

    Implicit information
      This member is added by an implicit conversion from XIncludeFilter to Ensuring[XIncludeFilter] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: (XIncludeFilter) ⇒ Boolean): XIncludeFilter

    Implicit information
      This member is added by an implicit conversion from XIncludeFilter to Ensuring[XIncludeFilter] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### def ensuring(cond: Boolean, msg: ⇒ Any): XIncludeFilter

    Implicit information
      This member is added by an implicit conversion from XIncludeFilter to Ensuring[XIncludeFilter] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: Boolean): XIncludeFilter

    Implicit information
      This member is added by an implicit conversion from XIncludeFilter to Ensuring[XIncludeFilter] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

20. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

21. #### def error(arg0: org.xml.sax.SAXParseException): Unit

    Definition Classes
      XMLFilterImpl → ErrorHandler
    Annotations
      @throws( classOf[org.xml.sax.SAXException] )

22. #### def fatalError(arg0: org.xml.sax.SAXParseException): Unit

    Definition Classes
      XMLFilterImpl → ErrorHandler
    Annotations
      @throws( classOf[org.xml.sax.SAXException] )

23. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

24. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from XIncludeFilter to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

25. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

26. #### def getContentHandler(): ContentHandler

    Definition Classes
      XMLFilterImpl → XMLReader

27. #### def getDTDHandler(): DTDHandler

    Definition Classes
      XMLFilterImpl → XMLReader

28. #### def getEntityResolver(): org.xml.sax.EntityResolver

    Definition Classes
      XMLFilterImpl → XMLReader

29. #### def getErrorHandler(): ErrorHandler

    Definition Classes
      XMLFilterImpl → XMLReader

30. #### def getFeature(arg0: String): Boolean

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws( ... ) @throws( ... )

31. #### def getParent(): XMLReader

    Definition Classes
      XMLFilterImpl → XMLFilter

32. #### def getProperty(arg0: String): AnyRef

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws( ... ) @throws( ... )

33. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

34. #### def ignorableWhitespace(ch: Array[Char], start: Int, length: Int): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

35. #### def insideIncludeElement(): Boolean

    This utility method returns true if and only if this reader is currently inside a non-empty include element.

    This utility method returns true if and only if this reader is currently inside a non-empty include element. (This is not the same as being inside the node set which replaces the include element.) This is primarily needed for comments inside include elements. It must be checked by the actual `LexicalHandler` to see whether a comment is passed or not.

    returns

      boolean

36. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

37. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

38. #### def notationDecl(arg0: String, arg1: String, arg2: String): Unit

    Definition Classes
      XMLFilterImpl → DTDHandler
    Annotations
      @throws( classOf[org.xml.sax.SAXException] )

39. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

40. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

41. #### def parse(arg0: String): Unit

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws( classOf[java.io.IOException] ) @throws( classOf[org.xml.sax.SAXException] )

42. #### def parse(arg0: org.xml.sax.InputSource): Unit

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws( classOf[java.io.IOException] ) @throws( classOf[org.xml.sax.SAXException] )

43. #### def processingInstruction(target: String, data: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

44. #### def resolveEntity(arg0: String, arg1: String): org.xml.sax.InputSource

    Definition Classes
      XMLFilterImpl → EntityResolver
    Annotations
      @throws( classOf[java.io.IOException] ) @throws( classOf[org.xml.sax.SAXException] )

45. #### def setContentHandler(arg0: ContentHandler): Unit

    Definition Classes
      XMLFilterImpl → XMLReader

46. #### def setDTDHandler(arg0: DTDHandler): Unit

    Definition Classes
      XMLFilterImpl → XMLReader

47. #### def setDocumentLocator(locator: Locator): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

48. #### def setEntityResolver(arg0: org.xml.sax.EntityResolver): Unit

    Definition Classes
      XMLFilterImpl → XMLReader

49. #### def setErrorHandler(arg0: ErrorHandler): Unit

    Definition Classes
      XMLFilterImpl → XMLReader

50. #### def setFeature(arg0: String, arg1: Boolean): Unit

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws( ... ) @throws( ... )

51. #### def setParent(arg0: XMLReader): Unit

    Definition Classes
      XMLFilterImpl → XMLFilter

52. #### def setProperty(arg0: String, arg1: Any): Unit

    Definition Classes
      XMLFilterImpl → XMLReader
    Annotations
      @throws( ... ) @throws( ... )

53. #### def skippedEntity(name: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

54. #### def startDocument(): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

55. #### def startElement(uri: String, localName: String, qName: String, atts1: Attributes): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

56. #### def startPrefixMapping(prefix: String, uri: String): Unit

    Definition Classes
      XIncludeFilter → XMLFilterImpl → ContentHandler

57. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

58. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

59. #### def unparsedEntityDecl(arg0: String, arg1: String, arg2: String, arg3: String): Unit

    Definition Classes
      XMLFilterImpl → DTDHandler
    Annotations
      @throws( classOf[org.xml.sax.SAXException] )

60. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

61. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

62. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

63. #### def warning(arg0: org.xml.sax.SAXParseException): Unit

    Definition Classes
      XMLFilterImpl → ErrorHandler
    Annotations
      @throws( classOf[org.xml.sax.SAXException] )

64. #### def →[B](y: B): (XIncludeFilter, B)

    Implicit information
      This member is added by an implicit conversion from XIncludeFilter to ArrowAssoc[XIncludeFilter] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from XIncludeFilter to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (xIncludeFilter: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from XIncludeFilter to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (xIncludeFilter: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: XIncludeFilter

   Implicit information
     This member is added by an implicit conversion from XIncludeFilter to ArrowAssoc[XIncludeFilter] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (xIncludeFilter: ArrowAssoc[XIncludeFilter]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: XIncludeFilter

   Implicit information
     This member is added by an implicit conversion from XIncludeFilter to Ensuring[XIncludeFilter] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (xIncludeFilter: Ensuring[XIncludeFilter]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from XMLFilterImpl

### Inherited from ErrorHandler

### Inherited from ContentHandler

### Inherited from DTDHandler

### Inherited from org.xml.sax.EntityResolver

### Inherited from XMLFilter

### Inherited from XMLReader

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from XIncludeFilter to StringAdd

### Inherited by implicit conversion any2stringfmt from XIncludeFilter to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from XIncludeFilter to ArrowAssoc[XIncludeFilter]

### Inherited by implicit conversion any2Ensuring from XIncludeFilter to Ensuring[XIncludeFilter]

### Ungrouped